/*-
 * Copyright (c) 2006 Fredrik Lindberg. <fli at shapeshifter dot se>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: int_bioapi.h 62 2008-03-15 11:23:39Z fli $
 */

#ifndef _INT_BIOAPI_H_
#define _INT_BIOAPI_H_

/*
 * Human readable list of loaded BSP modules
 */
struct bsp_list {
	char 	*bsp_uuid;
	int		bsp_index;
	char	*bsp_name;
	char	*bsp_desc;
	char 	*bsp_vend;
};

int bioapi_init(void);
void bioapi_destroy(void);
BioAPI_HANDLE * bioapi_attach_bsp(const char *);
void bioapi_detach_bsp(BioAPI_HANDLE *, const char *);
int bioapi_get_bsp_list(struct bsp_list **);
void bioapi_destroy_bsp_list(struct bsp_list *, size_t);
void bioapi_freebir(BioAPI_BIR *);
struct birdb_rec * bioapi_enroll(BioAPI_HANDLE *, struct birdb_mod *, void *,
    const char *);
int bioapi_verify(BioAPI_HANDLE *, struct birdb_rec *);
int bioapi_verify_many(BioAPI_HANDLE *, struct birdb_rec **);
int bioapi_identify(BioAPI_HANDLE *, struct birdb_mod *, void *, char **);

#endif /* _INT_BIOAPI_H_ */
